﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;

namespace _96274
{
    public partial class Form1 : Form
    {
        List<UltraTreeNode> MultiSelection = new List<UltraTreeNode>();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraTree1.ExpandAll();
            MultiSelection.Add(ultraTree1.GetNodeByKey("B"));
            MultiSelection.Add(ultraTree1.GetNodeByKey("D"));
           
        }

        private void ultraTree1_BeforeSelect(object sender, Infragistics.Win.UltraWinTree.BeforeSelectEventArgs e)
        {
           UltraTreeNode singleNodeSelection =  e.NewSelections.Cast<UltraTreeNode>().Where(n => CanMultiSelectioin(n.Parent) == false).FirstOrDefault<UltraTreeNode>();
           if (singleNodeSelection != null)
           {
               e.Cancel = true;
               ultraTree1.EventManager.AllEventsEnabled = false;
               ultraTree1.SelectedNodes.Clear();
               singleNodeSelection.Selected = true;
               ultraTree1.EventManager.AllEventsEnabled = true;
           }
        }

        private bool CanMultiSelectioin(UltraTreeNode node)
        {
            if (node == null)
                return false;
            if (MultiSelection.Contains(node))
                return true;
            else
                return CanMultiSelectioin(node.Parent);
        }
    }
}
